<?xml version="1.0" encoding="utf-8"?>
<databaseChangeLog
    xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
    xmlns:ext="http://www.liquibase.org/xml/ns/dbchangelog-ext"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-4.3.xsd
                        http://www.liquibase.org/xml/ns/dbchangelog-ext http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-ext.xsd">

    <!--
        Added the entity AppUser.
    -->
    <changeSet id="20210908091022-1" author="jhipster">
        <createTable tableName="app_user">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(255)">
                <constraints nullable="false" unique="true" uniqueConstraintName="ux_app_user__name" />
            </column>
            <column name="email" type="varchar(255)">
                <constraints nullable="false" unique="true" uniqueConstraintName="ux_app_user__email" />
            </column>
            <column name="password" type="varchar(255)">
                <constraints nullable="false" />
            </column>
            <column name="avatar" type="longblob">
                <constraints nullable="true" />
            </column>
            <column name="avatar_content_type" type="varchar(255)">
                <constraints nullable="true" />
            </column>
            <column name="email_verified_at" type="${datetimeType}">
                <constraints nullable="true" />
            </column>
            <column name="remember_token" type="varchar(255)">
                <constraints nullable="true" />
            </column>
            <column name="setting" type="varchar(255)">
                <constraints nullable="true" />
            </column>
            <column name="created_at" type="${datetimeType}">
                <constraints nullable="true" />
            </column>
            <column name="updated_at" type="${datetimeType}">
                <constraints nullable="true" />
            </column>
            <column name="access_token_id" type="bigint">
                <constraints nullable="true" unique="true" uniqueConstraintName="ux_app_user__access_token_id" />
            </column>
            <!-- jhipster-needle-liquibase-add-column - JHipster will add columns here -->
        </createTable>
        <dropDefaultValue tableName="app_user" columnName="email_verified_at" columnDataType="${datetimeType}"/>
        <dropDefaultValue tableName="app_user" columnName="created_at" columnDataType="${datetimeType}"/>
        <dropDefaultValue tableName="app_user" columnName="updated_at" columnDataType="${datetimeType}"/>
    </changeSet>

    <changeSet id="20210908091022-1-relations" author="jhipster">

        <createTable tableName="rel_app_user__role">
            <column name="role_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="app_user_id" type="bigint">
                <constraints nullable="false"/>
            </column>
        </createTable>

        <addPrimaryKey columnNames="app_user_id, role_id" tableName="rel_app_user__role"/>
    </changeSet>

    <!-- jhipster-needle-liquibase-add-changeset - JHipster will add changesets here -->

    <!--
        Load sample data generated with Faker.js
        - This data can be easily edited using a CSV editor (or even MS Excel) and
          is located in the 'src/main/resources/config/liquibase/fake-data' directory
        - By default this data is applied when running with the JHipster 'dev' profile.
          This can be customized by adding or removing 'faker' in the 'spring.liquibase.contexts'
          Spring Boot configuration key.
    -->
    <changeSet id="20210908091022-1-data" author="jhipster" context="faker">
        <loadData
                  file="config/liquibase/fake-data/app_user.csv"
                  separator=";"
                  tableName="app_user">
            <column name="id" type="numeric"/>
            <column name="name" type="string"/>
            <column name="email" type="string"/>
            <column name="password" type="string"/>
            <column name="avatar" type="blob"/>
            <column name="avatar_content_type" type="string"/>
            <column name="email_verified_at" type="${datetimeType}"/>
            <column name="remember_token" type="string"/>
            <column name="setting" type="string"/>
            <column name="created_at" type="${datetimeType}"/>
            <column name="updated_at" type="${datetimeType}"/>
            <!-- jhipster-needle-liquibase-add-loadcolumn - JHipster (and/or extensions) can add load columns here -->
        </loadData>
    </changeSet>
</databaseChangeLog>
